import QtQuick 2.7
import QtQuick.Controls 1.4
import QtQuick.Controls 2.0 as Controls2
import QtQuick.Layouts 1.1
import QtQuick.Controls.Styles 1.4
import Material 0.1

ApplicationWindow {
    visible: true
    width: Units.dp(800)
    height: Units.dp(600)
    title: qsTr("Hello World")

    /*Controls2.TabBar {
        id: tabBar
        height: 350
        width: parent.width
        background.visible: true
        Material.accent: Theme.accentColor

        Controls2.TabButton {
            height: 50
            text: qsTr("Home")
        }
        Controls2.TabButton {
            height: 50

            Label {
                style: "dialog"
                text: qsTr("Discover")
            }
        }
        Controls2.TabButton {
            height: 50
            text: qsTr("Activity")
        }
    }*/

    /*Item {
        width: parent.width
        height: Units.dp(400)
        enabled: false
        MouseArea {
            z:10
            enabled: true
            anchors.fill: parent
            onClicked: {
                console.log("test")
            }
        }
    }*/
    ListModel {
        id: myModel
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
        ListElement {
            myText: "test1"
        }
    }

    ListView {
        anchors.fill: parent

        spacing: Units.dp(10)
        clip: true

        model: myModel

        pressDelay: 300

        delegate: Rectangle {
            width: parent.width
            height: Units.dp(100)

            color: index % 2 ? "red" : "green"

            Loader {
                anchors.fill: parent
                sourceComponent: index % 2 ? flick: noFlick
            }

            Component {
                id: flick

                Rectangle {
                    anchors.fill: parent
                    anchors.margins: Units.dp(20)
                    color: "blue"
                    MouseArea {
                        anchors.fill: parent
                        propagateComposedEvents: true
                        drag.axis: Drag.XAxis
                        drag.minimumX: 0
                        z: 100000
                        hoverEnabled: true
                        onPositionChanged: {
                            if (containsPress){
                                console.log("Pos Changed");
                            }
                        }
                        onPressed: {
                            if (containsPress){
                                console.log("Pressed");
                            }
                        }
                        onReleased: {
                            if (containsMouse) {
                                console.log("Released");
                            }
                        }
                        onExited: {
                            console.log("Exited");
                        }
                    }
                }
            }

            Component {
                id: noFlick
                Item {
                    anchors.fill: parent
                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            console.log("Event Click");
                        }
                    }
                }
            }
        }
    }

    /*ScrollView {
        width: parent.width
        height: parent.height

        verticalScrollBarPolicy: Qt.ScrollBarAsNeeded
        horizontalScrollBarPolicy: Qt.ScrollBarAlwaysOff

        style: ScrollViewStyle {
            transientScrollBars: true
        }

        contentItem: Flickable {
            id: flickable
            contentWidth: sceneGenericDevice.width
            contentHeight: column2.implicitHeight

            clip: false
            flickableDirection: Flickable.VerticalFlick
            interactive: true
            pressDelay: 300

            Column {
                id: column2

                Controls2.Slider {
                    width: parent.width
                    height: 100
                    from: 0
                    to: 100
                    stepSize: 1
                }
            }
        }
    }*/

    /*Flickable {
        id: flickable
        contentWidth: parent.width
        contentHeight: {
            return column2.implicitHeight + Units.dp(10);
        }

        ScrollBar.vertical: ScrollBar {
            parent: flickable.parent
            anchors.top: flickable.top
            anchors.left: flickable.right
            anchors.bottom: flickable.bottom
        }

        clip: false
        flickableDirection: Flickable.VerticalFlick
        property bool isSliderPressed: false
        interactive: isSliderPressed ? false : true
        pressDelay: 200

        ColumnLayout {
            id: column2
            width: parent.width
            anchors.top: parent.top
            anchors.topMargin: Units.dp(15)
            anchors.right: parent.right
            anchors.left: parent.left


            Slider {
                id: slider
                Layout.preferredWidth: Units.dp(300)
                Layout.preferredHeight: Units.dp(100)
                stepSize: 1
                property real valueAtReal: position * (to-from) + from

                from: 0
                to: 100
                value: (from + to) / 2;

                onPressedChanged: {
                    if(pressed){
                        flickable.isSliderPressed = true;
                        value = (Math.round((sliderMouse.mouseX / sliderMouse.width * (to-from) + from) / stepSize) * stepSize).toFixed(1);
                    } else {
                        flickable.isSliderPressed = false;
                    }
                }

                background: Rectangle {
                    x: slider.leftPadding
                    y: slider.availableHeight / 2 - height / 2
                    implicitWidth: Units.dp(300)
                    implicitHeight: Units.dp(4)
                    width: slider.availableWidth
                    height: implicitHeight
                    radius: Units.dp(2)
                    color: slider.enabled ? Theme.smarthomeSliderBackgroundEnabledColor : Theme.smarthomeSliderBackgroundDisabledColor

                    Rectangle {
                        width: slider.visualPosition * parent.width
                        height: parent.height
                        color: slider.enabled ? Theme.smarthomeSliderHandlePressedColor : Theme.smarthomeSliderHandleReleasedColor
                        radius: Units.dp(2)
                    }
                }

                handle: Rectangle {
                    x: slider.leftPadding + slider.visualPosition * (slider.availableWidth - width)
                    y: slider.availableHeight / 2 - height / 2
                    implicitWidth: Units.dp(18)
                    implicitHeight: Units.dp(18)
                    radius: Units.dp(9)
                    color: slider.pressed ? Theme.smarthomeSliderHandlePressedColor : Theme.smarthomeSliderHandleReleasedColor
                    border.color: Theme.accentColor

                }

                onMoved: {
                    flickable.isSliderPressed = true;
                }

                MouseArea {
                    id: sliderMouse
                    anchors.fill: parent
                    onClicked: {
                        mouse.accepted = false;
                    }
                    onPositionChanged: {
                        mouse.accepted = false;
                    }
                    onPressed: {
                        //flickable.isSliderPressed = true;
                        mouse.accepted = false;
                    }
                    onReleased: {
                        //flickable.isSliderPressed = false;
                    }
                }
            }
        }
    }*/
}
